<template>
  <div class="main">
    <Card v-for="catelog in data" :key="catelog.id" :data="catelog" />
  </div>
  <img v-if="this.loading" src="../assets/loader.gif" />
  <div class="footer">Footer</div>
</template>

<script>
import Card from "./Card.vue";

export default {
  components: {
    Card,
  },
  data() {
    return {
      data: [],
      loading: false,
      dataLoaded: false,
      page: -1,
      dataOver: false,
    };
  },
  methods: {
    getData() {
      this.loading = true;
      this.axios
        .get(
          `https://catalogv2.getshitdone.in/api/app/search/catalog?query=mitali&page=${this.page}`
        )
        .then((res) => {
          console.log(res.data);
          this.data = [...this.data, ...res.data.payload.catalog];
        })
        .catch((err) => {
          // console.log("OVER");
          this.dataOver = true;
          // console.log(err.message);
        })
        .finally(() => {
          this.loading = false;
        });
    },
    callback(entry) {
      // console.log(entry[0].isIntersecting);
      if (
        entry[0].isIntersecting &&
        Math.floor(entry[0].intersectionRatio) === 1
      ) {
        if (!this.dataOver && !this.loading) {
          this.page++;
          this.getData();
        }
      }
    },
    loadDoc() {
      let options = {
        root: null,
        threshold: 1.0,
      };
      const observer = new IntersectionObserver(this.callback, options);

      let target = document.querySelector(".footer");
      observer.observe(target);
    },
    // async onScroll() {
    //   console.log(this.dataLoaded);
    //   if (
    //     document.documentElement.scrollTop + window.innerHeight + 5 >=
    //       document.documentElement.offsetHeight &&
    //     this.page <= 4
    //   ) {
    //     if (this.dataLoaded) {
    //       this.dataLoaded = false;
    //     } else {
    //       console.log(window.innerHeight + window.scrollY);
    //       console.log(document.body.offsetHeight);
    //       this.page++;
    //       await this.getData();
    //       this.dataLoaded = true;
    //     }
    //   }
    // },
  },
  mounted() {
    // window.addEventListener("scroll", this.onScroll);
    // this.getData();
    this.loadDoc();
  },
};
</script>

<style>
.main {
  display: grid;
  grid-template-columns: repeat(4, auto);

  /* display: flex;
  flex-wrap: wrap;
  justify-content: space-around; */
}

.footer {
  height: 20px;
  width: 100%;
  background: pink;
}
</style>
